<?php
/**
 * @package Iyosis Piwik for Joomla! 1.5
 * @author Remzi Degirmencioglu
 * @copyright (C) 2011 www.iyosis.com
 * @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
**/
 
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.model' );

class IyosisPiwikModelIyosisPiwik extends JModel
{

	function getData()
	{
		$db =& JFactory::getDBO();
		$query = ' SELECT * FROM #__iyosispiwik_config ';
		$db->setQuery( $query );
		$config = $db->loadObject();

		$this->httpURL = $config->httpURL;
		$this->idsite = $config->idsite;
		$this->period = $config->period;
		$this->date = $config->date;
		$this->token_auth = $config->token_auth;

		return $config;
	}

	function getVisits()
	{
		$widgetURL['getVisits'] = $this->httpURL;
		$widgetURL['getVisits'] .= "?module=API&method=VisitsSummary.get";
		$widgetURL['getVisits'] .= "&idSite=".$this->idsite."&period=day&date=last31";
		$widgetURL['getVisits'] .= "&format=PHP";
		$widgetURL['getVisits'] .= "&token_auth=".$this->token_auth;

		$fetchedVisitsWidget = file_get_contents($widgetURL['getVisits']);
		$Visits = unserialize($fetchedVisitsWidget);

		return $Visits;
	}

	function getVisitsReturning()
	{
		$widgetURL['getVisitsReturning'] = $this->httpURL;
		$widgetURL['getVisitsReturning'] .= "?module=API&method=VisitFrequency.getVisitsReturning";
		$widgetURL['getVisitsReturning'] .= "&idSite=".$this->idsite."&period=day&date=last31";
		$widgetURL['getVisitsReturning'] .= "&format=PHP";
		$widgetURL['getVisitsReturning'] .= "&token_auth=".$this->token_auth;

		$fetchedVisitsReturningWidget = file_get_contents($widgetURL['getVisitsReturning']);
		$VisitsReturning = unserialize($fetchedVisitsReturningWidget);

		return $VisitsReturning;
	}
	
	function getVisitDuration()
	{
		$widgetURL['getVisitDuration'] = $this->httpURL;
		$widgetURL['getVisitDuration'] .= "?module=API&method=VisitorInterest.getNumberOfVisitsPerVisitDuration";
		$widgetURL['getVisitDuration'] .= "&idSite=".$this->idsite."&period=".$this->period."&date=".$this->date;
		$widgetURL['getVisitDuration'] .= "&format=PHP&filter_limit=10";
		$widgetURL['getVisitDuration'] .= "&token_auth=".$this->token_auth;

		$fetchedgetVisitDurationWidget = file_get_contents($widgetURL['getVisitDuration']);
		$VisitDuration = unserialize($fetchedgetVisitDurationWidget);

		return $VisitDuration;
	}

	function getVisitsPerPage()
	{
		$widgetURL['getVisitsPerPage'] = $this->httpURL;
		$widgetURL['getVisitsPerPage'] .= "?module=API&method=VisitorInterest.getNumberOfVisitsPerPage";
		$widgetURL['getVisitsPerPage'] .= "&idSite=".$this->idsite."&period=".$this->period."&date=".$this->date;
		$widgetURL['getVisitsPerPage'] .= "&format=PHP&filter_limit=10";
		$widgetURL['getVisitsPerPage'] .= "&token_auth=".$this->token_auth;

		$fetchedgetVisitsPerPageWidget = file_get_contents($widgetURL['getVisitsPerPage']);
		$VisitsPerPage = unserialize($fetchedgetVisitsPerPageWidget);

		return $VisitsPerPage;
	}

	function getProvider()
	{
		$widgetURL['getProvider'] = $this->httpURL;
		$widgetURL['getProvider'] .= "?module=API&method=Provider.getProvider";
		$widgetURL['getProvider'] .= "&idSite=".$this->idsite."&period=".$this->period."&date=".$this->date;
		$widgetURL['getProvider'] .= "&format=PHP&filter_limit=100";
		$widgetURL['getProvider'] .= "&token_auth=".$this->token_auth;

		$fetchedgetProviderWidget = file_get_contents($widgetURL['getProvider']);
		$Provider = unserialize($fetchedgetProviderWidget);

		return $Provider;
	}

	function getCountry()
	{
		$widgetURL['getCountry'] = $this->httpURL;
		$widgetURL['getCountry'] .= "?module=API&method=UserCountry.getCountry";
		$widgetURL['getCountry'] .= "&idSite=".$this->idsite."&period=".$this->period."&date=".$this->date;
		$widgetURL['getCountry'] .= "&format=PHP&filter_limit=100";
		$widgetURL['getCountry'] .= "&token_auth=".$this->token_auth;

		$fetchedgetCountryWidget = file_get_contents($widgetURL['getCountry']);
		$Country = unserialize($fetchedgetCountryWidget);

		return $Country;
	}

	function getVisitsLocalTime()
	{
		$widgetURL['getVisitsLocalTime'] = $this->httpURL;
		$widgetURL['getVisitsLocalTime'] .= "?module=API&method=VisitTime.getVisitInformationPerLocalTime";
		$widgetURL['getVisitsLocalTime'] .= "&idSite=".$this->idsite."&period=".$this->period."&date=".$this->date;
		$widgetURL['getVisitsLocalTime'] .= "&format=PHP";
		$widgetURL['getVisitsLocalTime'] .= "&token_auth=".$this->token_auth;

		$fetchedgetVisitsLocalTimeWidget = file_get_contents($widgetURL['getVisitsLocalTime']);
		$VisitsLocalTime = unserialize($fetchedgetVisitsLocalTimeWidget);

		return $VisitsLocalTime;
	}

	function getVisitsServerTime()
	{
		$widgetURL['getVisitsServerTime'] = $this->httpURL;
		$widgetURL['getVisitsServerTime'] .= "?module=API&method=VisitTime.getVisitInformationPerServerTime";
		$widgetURL['getVisitsServerTime'] .= "&idSite=".$this->idsite."&period=".$this->period."&date=".$this->date;
		$widgetURL['getVisitsServerTime'] .= "&format=PHP";
		$widgetURL['getVisitsServerTime'] .= "&token_auth=".$this->token_auth;

		$fetchedgetVisitsServerTimeWidget = file_get_contents($widgetURL['getVisitsServerTime']);
		$VisitsServerTime = unserialize($fetchedgetVisitsServerTimeWidget);

		return $VisitsServerTime;
	}

	function getBrowserType()
	{
		$widgetURL['getBrowserType'] = $this->httpURL;
		$widgetURL['getBrowserType'] .= "?module=API&method=UserSettings.getBrowserType";
		$widgetURL['getBrowserType'] .= "&idSite=".$this->idsite."&period=".$this->period."&date=".$this->date;
		$widgetURL['getBrowserType'] .= "&format=PHP&filter_limit=10";
		$widgetURL['getBrowserType'] .= "&token_auth=".$this->token_auth;

		$fetchedBrowserTypeWidget = file_get_contents($widgetURL['getBrowserType']);
		$BrowserType = unserialize($fetchedBrowserTypeWidget);

		return $BrowserType;
	}

	function getBrowser()
	{
		$widgetURL['getBrowser'] = $this->httpURL;
		$widgetURL['getBrowser'] .= "?module=API&method=UserSettings.getBrowser";
		$widgetURL['getBrowser'] .= "&idSite=".$this->idsite."&period=".$this->period."&date=".$this->date;
		$widgetURL['getBrowser'] .= "&format=PHP&filter_limit=10";
		$widgetURL['getBrowser'] .= "&token_auth=".$this->token_auth;

		$fetchedBrowserWidget = file_get_contents($widgetURL['getBrowser']);
		$Browser = unserialize($fetchedBrowserWidget);

		return $Browser;
	}

	function getPlugin()
	{
		$widgetURL['getPlugin'] = $this->httpURL;
		$widgetURL['getPlugin'] .= "?module=API&method=UserSettings.getPlugin";
		$widgetURL['getPlugin'] .= "&idSite=".$this->idsite."&period=".$this->period."&date=".$this->date;
		$widgetURL['getPlugin'] .= "&format=PHP&filter_limit=10";
		$widgetURL['getPlugin'] .= "&token_auth=".$this->token_auth;

		$fetchedPluginWidget = file_get_contents($widgetURL['getPlugin']);
		$Plugin = unserialize($fetchedPluginWidget);

		return $Plugin;
	}

	function getConfiguration()
	{
		$widgetURL['getConfiguration'] = $this->httpURL;
		$widgetURL['getConfiguration'] .= "?module=API&method=UserSettings.getConfiguration";
		$widgetURL['getConfiguration'] .= "&idSite=".$this->idsite."&period=".$this->period."&date=".$this->date;
		$widgetURL['getConfiguration'] .= "&format=PHP&filter_limit=10";
		$widgetURL['getConfiguration'] .= "&token_auth=".$this->token_auth;

		$fetchedConfigurationWidget = file_get_contents($widgetURL['getConfiguration']);
		$Configuration = unserialize($fetchedConfigurationWidget);

		return $Configuration;
	}

	function getResolution()
	{
		$widgetURL['getResolution'] = $this->httpURL;
		$widgetURL['getResolution'] .= "?module=API&method=UserSettings.getResolution";
		$widgetURL['getResolution'] .= "&idSite=".$this->idsite."&period=".$this->period."&date=".$this->date;
		$widgetURL['getResolution'] .= "&format=PHP&filter_limit=10";
		$widgetURL['getResolution'] .= "&token_auth=".$this->token_auth;

		$fetchedResolutionWidget = file_get_contents($widgetURL['getResolution']);
		$Resolution = unserialize($fetchedResolutionWidget);

		return $Resolution;
	}

	function getOS()
	{
		$widgetURL['getOS'] = $this->httpURL;
		$widgetURL['getOS'] .= "?module=API&method=UserSettings.getOS";
		$widgetURL['getOS'] .= "&idSite=".$this->idsite."&period=".$this->period."&date=".$this->date;
		$widgetURL['getOS'] .= "&format=PHP&filter_limit=10";
		$widgetURL['getOS'] .= "&token_auth=".$this->token_auth;

		$fetchedOSWidget = file_get_contents($widgetURL['getOS']);
		$OS = unserialize($fetchedOSWidget);

		return $OS;
	}

	function getPageUrls()
	{
		$task = JRequest::getVar('task');

		$widgetURL['getPageUrls'] = $this->httpURL;
		$widgetURL['getPageUrls'] .= "?module=API&method=Actions.getPageUrls";
		$widgetURL['getPageUrls'] .= "&idSite=".$this->idsite."&period=".$this->period."&date=".$this->date;
		if($task=='pages') {
			$widgetURL['getPageUrls'] .= "&format=PHP&filter_limit=100";
		} else {
			$widgetURL['getPageUrls'] .= "&format=PHP&filter_limit=20";
		}
		$widgetURL['getPageUrls'] .= "&token_auth=".$this->token_auth;

		$fetchedPagesWidget = file_get_contents($widgetURL['getPageUrls']);
		$PageUrls = unserialize($fetchedPagesWidget);

		return	$PageUrls;
	}

	function getPageTitles()
	{
		$widgetURL['getPageTitles'] = $this->httpURL;
		$widgetURL['getPageTitles'] .= "?module=API&method=Actions.getPageTitles";
		$widgetURL['getPageTitles'] .= "&idSite=".$this->idsite."&period=".$this->period."&date=".$this->date;
		$widgetURL['getPageTitles'] .= "&format=PHP&filter_limit=100";
		$widgetURL['getPageTitles'] .= "&token_auth=".$this->token_auth;

		$fetchedPageTitlesWidget = file_get_contents($widgetURL['getPageTitles']);
		$PageTitles = unserialize($fetchedPageTitlesWidget);

		return $PageTitles;
	}

	function getOutlinks()
	{
		$widgetURL['getOutlinks'] = $this->httpURL;
		$widgetURL['getOutlinks'] .= "?module=API&method=Actions.getOutlinks";
		$widgetURL['getOutlinks'] .= "&idSite=".$this->idsite."&period=".$this->period."&date=".$this->date;
		$widgetURL['getOutlinks'] .= "&format=PHP&filter_limit=50";
		$widgetURL['getOutlinks'] .= "&token_auth=".$this->token_auth;

		$fetchedOutlinksWidget = file_get_contents($widgetURL['getOutlinks']);
		$Outlinks = unserialize($fetchedOutlinksWidget);

		return $Outlinks;
	}

	function getRefererType()
	{
		$widgetURL['getRefererType'] = $this->httpURL;
		$widgetURL['getRefererType'] .= "?module=API&method=Referers.getRefererType";
		$widgetURL['getRefererType'] .= "&idSite=".$this->idsite."&period=".$this->period."&date=last31";
		$widgetURL['getRefererType'] .= "&format=PHP";
		$widgetURL['getRefererType'] .= "&token_auth=".$this->token_auth;

		$fetchedRefererTypeWidget = file_get_contents($widgetURL['getRefererType']);
		$RefererType = unserialize($fetchedRefererTypeWidget);

		return $RefererType;
	}


	function getSearchEngines()
	{
		$widgetURL['getSearchEngines'] = $this->httpURL;
		$widgetURL['getSearchEngines'] .= "?module=API&method=Referers.getSearchEngines";
		$widgetURL['getSearchEngines'] .= "&idSite=".$this->idsite."&period=".$this->period."&date=".$this->date;
		$widgetURL['getSearchEngines'] .= "&format=PHP&filter_limit=20";
		$widgetURL['getSearchEngines'] .= "&token_auth=".$this->token_auth;

		$fetchedWidgetSearchEngines = file_get_contents($widgetURL['getSearchEngines']);
		$SearchEngines = unserialize($fetchedWidgetSearchEngines);

		return $SearchEngines;
	}

	function getKeywords()
	{
		$task = JRequest::getVar('task');

		$widgetURL['getKeywords'] = $this->httpURL;
		$widgetURL['getKeywords'] .= "?module=API&method=Referers.getKeywords";
		$widgetURL['getKeywords'] .= "&idSite=".$this->idsite."&period=".$this->period."&date=".$this->date;
		if($task=='searchengines') {
			$widgetURL['getKeywords'] .= "&format=PHP&filter_limit=100";
		} else {
			$widgetURL['getKeywords'] .= "&format=PHP&filter_limit=10";
		}
		$widgetURL['getKeywords'] .= "&token_auth=".$this->token_auth;

		$fetchedKeywordsWidget = file_get_contents($widgetURL['getKeywords']);
		$Keywords = unserialize($fetchedKeywordsWidget);

		return $Keywords;
	}

	function getWebsites()
	{
		$task = JRequest::getVar('task');

		$widgetURL['getWebsites'] = $this->httpURL;
		$widgetURL['getWebsites'] .= "?module=API&method=Referers.getWebsites";
		$widgetURL['getWebsites'] .= "&idSite=".$this->idsite."&period=".$this->period."&date=".$this->date;
		if($task=='websites') {
			$widgetURL['getWebsites'] .= "&format=PHP&filter_limit=100";
		} else {
			$widgetURL['getWebsites'] .= "&format=PHP&filter_limit=10";
		}
		$widgetURL['getWebsites'] .= "&token_auth=".$this->token_auth;

		$fetchedWebsitesWidget = file_get_contents($widgetURL['getWebsites']);
		$Websites = unserialize($fetchedWebsitesWidget);

		return $Websites;
	}
}
